include BTSS-3.1.dat
# Makefile for NRM Release installation
#       (C) PowerStone GmbH 1994
#
# SCCSid.:      @(#)btss.make	1.16	95/06/02

# This Makefile contains the NRM specific installation targets.
#
# It is called from the automatic generated makefile 'install.mk', which
# will be generated by 'p_config' during the global installation.
#
# During the installtion this file becomes extended by 
#	include <tar_file_base_name>.dat
# in the first line. That file contains definitions of environment
# variables got from the administrator during the installation.
#
# These environment variables used in this Makefile are :
#
#	HOST_OS		  : Host operating system (SunOS4 or SunOS5)
#
#	PRODUCT_NAME	  : Name of the NRM Product
#	PRODUCT_PATH	  : Path where NRM is going to be installed
#	PRODUCT_OWNER	  : Desired owner for the NRM product files
#	PRODUCT_GROUP	  : Desired group for the NRM product files
#	PRODUCT_ACCESS	  : Desired access rights for others for NRM files
#	PRODUCT_VERSION	  : Version number of NRM with Patch in brackets
#
# All 'TARGET' definitions in the .descr file must correspond to a target
# defined in this Makefile. 

.SILENT:

BINDIR	= /usr/bin

# Entries for trans_conf file:
SCSI-T_SunOS5 	= SCSI-T	/dev/rmt/0	BBK-SCSI device for Solaris (uses ../0 to ../3)
SCSI-T_SunOS4 	= SCSI-T	/dev/rst0	BBK-SCSI device for SunOS 4 (uses rst0 to rst3)
BBKS4		= BBKS4	1		BBK-S4 board in SBus slot 1
VMTM		= VMTM	80000000	VMTM board 0 at VME address 0x80000000
VMTM-24BIT	= VMTM	800000		VMTM board 0 at VME address 0x800000 24bit

SEM_KEY		= 0x42424242


#-----------------------------------------------------------------------------
# special bus installation
# SCSI-Bus, S-Bus and VME-Bus 32 bit can use lconf.sbus.o

24-bit_vmebus : vmebus_install
	@echo "* installing 24 bit VME-Bus stuff"
	cp -p ../config/$(HOST_OS)/links.vme24bit ../links
	cp -p ../config/$(HOST_OS)/ulti.vme24bit ../ulti
	cp -p ../config/$(HOST_OS)/vmtmconf.vme24bit ../vmtmconf
	cp -p ../link_c/$(HOST_OS)/lconf.vme24bit.o  ../lconf.o
	chown $(PRODUCT_OWNER) ../vmtmconf ../ulti ../links ../lconf.o
	chgrp $(PRODUCT_GROUP) ../vmtmconf ../ulti ../links ../lconf.o
	chmod ug+xs ../vmtmconf ../ulti ../links
	chmod og-w ../vmtmconf ../ulti ../links ../lconf.o
	if test "$(PRODUCT_ACCESS)" = "0";	\
	then	\
		chmod o-rwx ../vmtmconf ../ulti ../links ../lconf.o;	\
	fi
	(egrep '^0' ../config/trans_conf >/dev/null && egrep '^1' ../config/trans_conf >/dev/null && echo "2	$(VMTM-24BIT)" >>  ../config/trans_conf) || (egrep '^0' ../config/trans_conf >/dev/null && echo "1	$(VMTM-24BIT)" >> ../config/trans_conf) ||  (echo "0	$(VMTM-24BIT)" >> ../config/trans_conf)


32-bit_vmebus : vmebus_install
	@echo "* installing 32 bit VME-Bus stuff"
	(egrep '^0' ../config/trans_conf >/dev/null && egrep '^1' ../config/trans_conf >/dev/null && echo "2	$(VMTM)" >>  ../config/trans_conf) || (egrep '^0' ../config/trans_conf >/dev/null && echo "1	$(VMTM)" >> ../config/trans_conf) ||  (echo "0	$(VMTM)" >> ../config/trans_conf)


vmebus_install :
	@echo "* installing VME-Bus stuff"
	cp -p ../config/vmtmconf.cde ..
	chown $(PRODUCT_OWNER) ../vmtmconf.cde
	chgrp $(PRODUCT_GROUP) ../vmtmconf.cde
	if test "$(PRODUCT_ACCESS)" = "0";	\
	then	\
		chmod o-rwx ../vmtmconf.cde;	\
	fi


sbus_install:
	@echo "* installing S-Bus stuff"
	cp -p ../config/$(HOST_OS)/s4diag ..
	chgrp $(PRODUCT_GROUP) ../s4diag
	chown $(PRODUCT_OWNER) ../s4diag
	chmod og-rwx ../s4diag
	chmod ug+sx ../s4diag
	(egrep '^0' ../config/trans_conf >/dev/null && egrep '^1' ../config/trans_conf >/dev/null && echo "2	$(BBKS4)" >>  ../config/trans_conf) || (egrep '^0' ../config/trans_conf >/dev/null && echo "1	$(BBKS4)" >> ../config/trans_conf) ||  (echo "0	$(BBKS4)" >> ../config/trans_conf)


scsi_install:
	@echo "* installing SCSI-Bus stuff"
	if test "$(HOST_OS)" = "SunOS5"; then		\
		(egrep '^0' ../config/trans_conf >/dev/null && egrep '^1' ../config/trans_conf >/dev/null && echo "2	$(SCSI-T_SunOS5)" >>  ../config/trans_conf) || (egrep '^0' ../config/trans_conf >/dev/null && echo "1	$(SCSI-T_SunOS5)" >> ../config/trans_conf) ||  (echo "0	$(SCSI-T_SunOS5)" >> ../config/trans_conf);\
	else						\
		(egrep '^0' ../config/trans_conf >/dev/null && egrep '^1' ../config/trans_conf >/dev/null && echo "2	$(SCSI-T_SunOS4)" >>  ../config/trans_conf) || (egrep '^0' ../config/trans_conf >/dev/null && echo "1	$(SCSI-T_SunOS4)" >> ../config/trans_conf) ||  (echo "0	$(SCSI-T_SunOS4)" >> ../config/trans_conf);\
	fi


#-----------------------------------------------------------------------------
#installations always done

default_install:
	cp -p ../config/$(HOST_OS)/links ..
	cp -p ../config/$(HOST_OS)/ulti ..
	cp -p ../config/$(HOST_OS)/vmtmconf ..
	cp -p ../link_c/$(HOST_OS)/lconf.o ..
	chown $(PRODUCT_OWNER) ../vmtmconf ../ulti ../links ../lconf.o
	chgrp $(PRODUCT_GROUP) ../vmtmconf ../ulti ../links ../lconf.o
	chmod ug+xs ../vmtmconf ../ulti ../links
	chmod og-w ../vmtmconf ../ulti ../links ../lconf.o
	if test "$(PRODUCT_ACCESS)" = "0";	\
	then	\
		chmod o-rwx  ../vmtmconf ../ulti ../links ../lconf.o;	\
	fi
	chmod 700 ../scsi_tools/SunOS?/burn_scsi
	-chown root ../scsi_tools/SunOS?/burn_scsi
	chmod 700 burn_scsi_install
	-chown root burn_scsi_install

global_install: default_install
	@echo "* copying prepared object files into corresponding directories"
	cp -p ../link_c/link.h	 		..
	cp -p ../link_c/parsylink.h	  	..
	cp -p ../scsi_tools/scsi_bridge.h	..
	cp -p ../link_c/$(HOST_OS)/link.o  	..
	cp -p ../link_c/$(HOST_OS)/parsylink.o 	..

	@echo "* copying prepared binaries to $(PRODUCT_PATH)"
	cp -p ../config/trans.cde 		..

	cp -p ../config/trans_conf_header ../config/trans_conf
	if test -f $(PRODUCT_PATH)/makefile; then \
		echo "* moving 'makefile' to 'makefile.old' in '$(PRODUCT_PATH)'";	  \
		mv $(PRODUCT_PATH)/makefile $(PRODUCT_PATH)/makefile.old; \
	fi

	chown $(PRODUCT_OWNER) ../link.h ../parsylink.h ../scsi_bridge.h ../link.o ../parsylink.o ../trans.cde ../config/trans_conf
	chgrp $(PRODUCT_GROUP) ../link.h ../parsylink.h ../scsi_bridge.h ../link.o ../parsylink.o ../trans.cde ../config/trans_conf
	if test "$(PRODUCT_ACCESS)" = "0";	\
	then	\
		chmod o-rwx  ../link.h ../parsylink.h ../scsi_bridge.h ../link.o ../parsylink.o ../trans.cde ../config/trans_conf;	\
	fi

trans_conf_install:
	@echo "* installing example configuration"
	cp -p ../config/trans_conf ..
	chown $(PRODUCT_OWNER) ../trans_conf
	chgrp $(PRODUCT_GROUP) ../trans_conf
	chmod o-wx ../trans_conf
	chmod o+r ../trans_conf


#-----------------------------------------------------------------------------
general_tools :
	@echo "* installing general BTSS tools to $(BINDIR)"
	rm -f $(BINDIR)/ulti $(BINDIR)/links
	cp -p ../ulti ../links $(BINDIR)
	chgrp $(PRODUCT_GROUP) $(BINDIR)/ulti $(BINDIR)/links
	chown $(PRODUCT_OWNER) $(BINDIR)/ulti $(BINDIR)/links
	chmod ug+xs $(BINDIR)/ulti $(BINDIR)/links
	chmod og-w $(BINDIR)/ulti $(BINDIR)/links
	chmod og+rx $(BINDIR)/ulti $(BINDIR)/links


sbus_tools :
	@echo "* installing BTSS S-Bus tools to $(BINDIR)"
	rm -f $(BINDIR)/s4diag
	cp -p ../config/$(HOST_OS)/s4diag $(BINDIR)
	chgrp $(PRODUCT_GROUP) $(BINDIR)/s4diag
	chown $(PRODUCT_OWNER) $(BINDIR)/s4diag
	chmod og-rwx $(BINDIR)/s4diag
	chmod ug+sx $(BINDIR)/s4diag

#-----------------------------------------------------------------------------
# Targets for the second step (re-installation) 

first_ulti:
	@echo "* initializing link adapter semaphore"
	@if test -f $(PRODUCT_PATH)/trans_conf; then	\
		:;					\
	else				\
		echo "missing configuration file '$(PRODUCT_PATH)/trans_conf'";\
		exit 1;					\
	fi
	TRANSP_CONFIG=$(PRODUCT_PATH)/trans_conf; export TRANSP_CONFIG; $(PRODUCT_PATH)/ulti | fgrep -v "Testing transputer link" || echo " " > /dev/null
	@echo "* checking semaphore ..."
	(ipcs -sb | fgrep "$(SEM_KEY)" | fgrep "$(PRODUCT_GROUP)" >/dev/null && echo "				... ok." ) || (echo " " && echo " " && echo "W A R N I N G :   Initialization of link adapter semaphore may have failed !!!" && echo " " && echo "Please, analyse the semaphore with key '$(SEM_KEY)':" && echo " " && ipcs -sb  && echo " " && echo "--> If the semaphore is not listed (may occur under Solaris) control is not " && echo "    possible. It may be ok, but also you might expect problems with semaphores." && echo "--> If the semaphore exists, but does not belong to the group '$(PRODUCT_GROUP)'" && echo "    delete it by 'ipcrm -s <semid>' and repeat re-installation." && echo " " && echo " " )



burn_scsi_firmware:
	@echo "* BBK-SCSI firmware burn in"
	-./burn_scsi_install $(PRODUCT_PATH)/scsi_tools/$(HOST_OS) $(PRODUCT_PATH)/scsi_tools/scsi.bin $(PRODUCT_PATH)/trans_conf 
